#ifndef __DirectoryData_Authorization_h__
#define __DirectoryData_Authorization_h__

#include <DirectoryData/DirectoryData.h>

#include <Auth4cData/Product.h>
#include <Auth4cData/Permission.h>
#include <Auth4cData/AuthenticatedUser.h>
#include <Auth4cData/Factory.h>

#include <librfcdal/DalDatabase.h>

namespace DirectoryData
{
	class DirectoryData_Export Authorization
	{
		public:
			static const Auth4cData::Product productDirectoryManager;
			static const Auth4cData::Permission permissionRead;
			static const Auth4cData::Permission permissionMaintain;
			static const Auth4cData::Permission permissionAdminister;

			enum Action{ actDelete = 'D', actInsert = 'I', actUpdate = 'U' };

			static void logEntry( const Auth4cData::AuthenticatedUser& user, Action action, const std::string& strTarget, const std::string& strLegend );
			static void logEntry( const Auth4cData::AuthenticatedUser& user, Action action, const std::string& strTarget, const std::string& strLegend, RfcDal::DalDatabase& db );
	};
}

#endif /* !__DirectoryData_Authorization_h__ */
