#ifndef __DirectoryData_Enumerator_h__
#define __DirectoryData_Enumerator_h__

#include <DirectoryData/Base.h>

namespace DirectoryData
{
	class DirectoryData_Export Enumerator : public Base
	{
		public:
			class DirectoryData_Export Key : public Base::Key
			{
				private:
					std::string _strEnumerator;

				public:
					Key();
					Key( const std::string& strEnumerator );
					Key( const Key& key );
					virtual ~Key();

					Key& operator=( const Key& key );
					bool operator==( const Key& key ) const;
					bool operator!=( const Key& key ) const;
					bool operator<( const Key& key ) const;

					const std::string& enumerator() const;

					virtual std::string str() const;
			};

		private:
			Key _key;
			std::string _strDescription;

		public:
			Enumerator();
			Enumerator( const Enumerator::Key& key );
			Enumerator( const Enumerator& enumerator );

			Enumerator& operator=( const Enumerator& enumerator );
			virtual Enumerator& merge( const Enumerator& enumerator );

			const Key& key() const;
			const std::string& description() const;

			void setDescription( const std::string& strDescription );
	};
}

#endif /* !__DirectoryData_Enumerator_h__*/
