#ifndef __DirectoryData_Exception_h__
#define __DirectoryData_Exception_h__

#include <DirectoryData/DirectoryData.h>

#include <Base4c/Exception.h>

#include <string>
#include <vector>

namespace DirectoryData
{
	const int DEX_INVALIDLINE = -1;

	static const int DEX_COMPOUNDEXCEPTION = Base4c::B4CX_DERIVEDBASE;
	static const int DEX_ALIENEXCEPTION = Base4c::B4CX_DERIVEDBASE + 1;
	static const int DEX_DALEXCEPTION = Base4c::B4CX_DERIVEDBASE + 2;
	static const int DEX_AUTHEXCEPTION = Base4c::B4CX_DERIVEDBASE + 3;
	static const int DEX_ISOEXCEPTION = Base4c::B4CX_DERIVEDBASE + 4;
	static const int DEX_MAILEXCEPTION = Base4c::B4CX_DERIVEDBASE + 5;
	static const int DEX_APPLICATIONABORTED = Base4c::B4CX_DERIVEDBASE + 8;
	static const int DEX_NOCONNECTSTRING = Base4c::B4CX_DERIVEDBASE + 10;
	static const int DEX_PERMISSIONDENIED = Base4c::B4CX_DERIVEDBASE + 15;
	static const int DEX_INCOMPLETEDATASET = Base4c::B4CX_DERIVEDBASE + 50;
	static const int DEX_CREATEFAILED = Base4c::B4CX_DERIVEDBASE + 55;
	static const int DEX_RETRIEVEFAILED = Base4c::B4CX_DERIVEDBASE + 56;
	static const int DEX_UPDATEFAILED = Base4c::B4CX_DERIVEDBASE + 57;
	static const int DEX_DELETEFAILED = Base4c::B4CX_DERIVEDBASE + 58;
	static const int DEX_MODIFYPAST = Base4c::B4CX_DERIVEDBASE + 59;
	static const int DEX_WINDOWALREADYOPEN = Base4c::B4CX_DERIVEDBASE + 70;
	static const int DEX_FILEOPENFAILED = Base4c::B4CX_DERIVEDBASE + 80;
	static const int DEX_NOSUCHDOMAIN = Base4c::B4CX_DERIVEDBASE + 99;
	static const int DEX_NOSUCHMERCHANTTYPE = Base4c::B4CX_DERIVEDBASE + 100;
	static const int DEX_NOSUCHINCORPORATION = Base4c::B4CX_DERIVEDBASE + 101;
	static const int DEX_NOSUCHFOOD = Base4c::B4CX_DERIVEDBASE + 102;
	static const int DEX_NOSUCHPITCHTYPE = Base4c::B4CX_DERIVEDBASE + 103;
	static const int DEX_NOSUCHMASTERCATEGORY = Base4c::B4CX_DERIVEDBASE + 104;
	static const int DEX_NOSUCHCATEGORY = Base4c::B4CX_DERIVEDBASE + 105;
	static const int DEX_NOSUCHADDRESSTEMPLATE = Base4c::B4CX_DERIVEDBASE + 106;
	static const int DEX_NOSUCHADDRESS = Base4c::B4CX_DERIVEDBASE + 107;
	static const int DEX_NOSUCHCOUNTRY = Base4c::B4CX_DERIVEDBASE + 108;
	static const int DEX_NOSUCHSUBDIVISION = Base4c::B4CX_DERIVEDBASE + 109;
	static const int DEX_NOSUCHMERCHANT = Base4c::B4CX_DERIVEDBASE + 110;
	static const int DEX_NOSUCHFESTIVALSTATUS = Base4c::B4CX_DERIVEDBASE + 111;
	static const int DEX_NOSUCHFESTIVAL = Base4c::B4CX_DERIVEDBASE + 112;
	static const int DEX_NOSUCHFESTIVALBOOKING = Base4c::B4CX_DERIVEDBASE + 113;
	static const int DEX_NOSUCHPITCH = Base4c::B4CX_DERIVEDBASE + 114;
	static const int DEX_NOSUCHSTAGE = Base4c::B4CX_DERIVEDBASE + 115;
	static const int DEX_NOSUCHACT = Base4c::B4CX_DERIVEDBASE + 116;
	static const int DEX_NOSUCHGALLERY = Base4c::B4CX_DERIVEDBASE + 117;
	static const int DEX_NOSUCHGALLERYIMAGE = Base4c::B4CX_DERIVEDBASE + 118;
	static const int DEX_NOSUCHMESSAGESTATUS = Base4c::B4CX_DERIVEDBASE + 119;
	static const int DEX_NOSUCHSENDER = Base4c::B4CX_DERIVEDBASE + 120;
	static const int DEX_NOSUCHPRODUCT = Base4c::B4CX_DERIVEDBASE + 121;
	static const int DEX_NOMERCHANTTYPESET = Base4c::B4CX_DERIVEDBASE + 200;
	static const int DEX_NOINCORPORATIONSET = Base4c::B4CX_DERIVEDBASE + 201;
	static const int DEX_NOFOODSET = Base4c::B4CX_DERIVEDBASE + 202;
	static const int DEX_NOPITCHTYPESET = Base4c::B4CX_DERIVEDBASE + 203;
	static const int DEX_NOMASTERCATEGORYSET = Base4c::B4CX_DERIVEDBASE + 204;
	static const int DEX_NOCATEGORYSET = Base4c::B4CX_DERIVEDBASE + 205;
	static const int DEX_NOADDRESSTEMPLATESET = Base4c::B4CX_DERIVEDBASE + 206;
	static const int DEX_NOADDRESSSET = Base4c::B4CX_DERIVEDBASE + 207;
	static const int DEX_NOCOUNTRYSET = Base4c::B4CX_DERIVEDBASE + 208;
	static const int DEX_NOSUBDIVISIONSET = Base4c::B4CX_DERIVEDBASE + 209;
	static const int DEX_NOMERCHANTSET = Base4c::B4CX_DERIVEDBASE + 210;
	static const int DEX_NOFESTIVALSTATUSSET = Base4c::B4CX_DERIVEDBASE + 211;
	static const int DEX_NOFESTIVALSET = Base4c::B4CX_DERIVEDBASE + 212;
	static const int DEX_NOFESTIVALBOOKINGSET = Base4c::B4CX_DERIVEDBASE + 213;
	static const int DEX_NOPITCHSET = Base4c::B4CX_DERIVEDBASE + 214;
	static const int DEX_NOSTAGESET = Base4c::B4CX_DERIVEDBASE + 215;
	static const int DEX_NOACTSET = Base4c::B4CX_DERIVEDBASE + 216;
	static const int DEX_NOGALLERYSET = Base4c::B4CX_DERIVEDBASE + 217;
	static const int DEX_NOGALLERYIMAGESET = Base4c::B4CX_DERIVEDBASE + 218;
	static const int DEX_NOMESSAGESTATUSSET = Base4c::B4CX_DERIVEDBASE + 219;
	static const int DEX_NOSENDERSET = Base4c::B4CX_DERIVEDBASE + 220;

	static const int DEX_NOMAILERSET = Base4c::B4CX_DERIVEDBASE + 280;
	static const int DEX_MESSAGESTATEINVALID = Base4c::B4CX_DERIVEDBASE + 290;
	static const int DEX_RECIPIENTINVALID = Base4c::B4CX_DERIVEDBASE + 291;

	static const int DEX_VAL_PITCHDOUBLEBOOKED = Base4c::B4CX_DERIVEDBASE + 330;

	static const int DEX_VAL_MSGMAX = Base4c::B4CX_DERIVEDBASE + 349;

	static const int DEX_VAL_FESTIVALBOOKINGHASTOOMANYPITCHBOOKINGS = Base4c::B4CX_DERIVEDBASE + 350;
	static const int DEX_VAL_MERCHANTHASCOMMENT1 = Base4c::B4CX_DERIVEDBASE + 351;

	static const int DEX_VAL_WARNMAX = Base4c::B4CX_DERIVEDBASE + 399;

	static const int DEX_VAL_FESTIVALBOOKINGHASNOPITCHBOOKINGS = Base4c::B4CX_DERIVEDBASE + 400;
	static const int DEX_VAL_FESTIVALBOOKINGHASINSUFFICIENTPITCHBOOKINGS = Base4c::B4CX_DERIVEDBASE + 401;
	static const int DEX_VAL_FOODPERMITREQUIREDBUTNOTRECEIVED = Base4c::B4CX_DERIVEDBASE + 402;
	static const int DEX_VAL_MERCHANTHASCOMMENT2 = Base4c::B4CX_DERIVEDBASE + 403;

	class DirectoryData_Export Exception : public Base4c::Exception
	{
		public:
			Exception( const std::string& strFile, int nLine, int nErrorCode, bool bFatal = false, const std::string& strLegend = std::string() );

			static std::string explainErrorCode( int nErrorCode );
	};

	class DirectoryData_Export ExceptionList : public std::vector<Exception>
	{
	};

	class DirectoryData_Export CompoundException : public Exception
	{
		private:
			ExceptionList _exceptionS;

		public:
			CompoundException();
			CompoundException( const std::string& strFile, int nLine );
			virtual ~CompoundException();

			const CompoundException& operator=( const CompoundException& e );

			bool hasExceptions() const;
			const ExceptionList& exceptions() const;
			void addException( const Exception& e );
			void addExceptions( const ExceptionList& e );
	};
}

#endif /* __DirectoryData_Exception_h__ */
