#ifndef __DirectoryData_FestivalStatus_h__
#define __DirectoryData_FestivalStatus_h__

#include <DirectoryData/Enumerator.h>
#include <DirectoryData/Exception.h>

#include <librfcdal/DalDatabase.h>

#include <map>

namespace DirectoryData
{
	class DirectoryData_Export FestivalStatus : public Enumerator
	{
		public:
			static const Key festivalNew;

		public:
			FestivalStatus();
			FestivalStatus( const FestivalStatus::Key & key );
			FestivalStatus( const FestivalStatus& type );
			virtual ~FestivalStatus();

			FestivalStatus& operator=( const FestivalStatus& type );

			static FestivalStatus fromRow( const RfcDal::DalDatabase::Row& row ) throw( DirectoryData::Exception );
	};

	class DirectoryData_Export FestivalStatusMap : public std::map<FestivalStatus::Key, FestivalStatus>
	{
		public:
			static FestivalStatusMap fromResult( const RfcDal::DalDatabase::Result& result ) throw( DirectoryData::Exception );
	};
}

#endif /* !__DirectoryData_FestivalStatus_h__ */
