#ifndef __DirectoryData_Food_h__
#define __DirectoryData_Food_h__

#include <DirectoryData/Enumerator.h>
#include <DirectoryData/Exception.h>

#include <librfcdal/DalDatabase.h>

#include <map>

namespace DirectoryData
{
	class DirectoryData_Export Food : public Enumerator
	{
		private:
			bool _bRequiresPermit;

		public:
			Food();
			Food( const Food::Key & key );
			Food( const Food& type );
			virtual ~Food();

			Food& operator=( const Food& type );
			Food& merge( const Food& type );

			bool requiresPermit() const;

			void setRequiresPermit( bool bRequiresPermit );

			static Food fromRow( const RfcDal::DalDatabase::Row& row ) throw( DirectoryData::Exception );
	};

	class DirectoryData_Export FoodMap : public std::map<Food::Key, Food>
	{
		public:
			static FoodMap fromResult( const RfcDal::DalDatabase::Result& result ) throw( DirectoryData::Exception );
	};
}

#endif /* !__DirectoryData_Food_h__ */
