#ifndef __DirectoryData_Incorporation_h__
#define __DirectoryData_Incorporation_h__

#include <DirectoryData/Enumerator.h>
#include <DirectoryData/Exception.h>

#include <librfcdal/DalDatabase.h>

#include <map>

namespace DirectoryData
{
	class DirectoryData_Export Incorporation : public Enumerator
	{
		public:
			Incorporation();
			Incorporation( const Incorporation::Key & key );
			Incorporation( const Incorporation& type );
			virtual ~Incorporation();

			Incorporation& operator=( const Incorporation& type );

			static Incorporation fromRow( const RfcDal::DalDatabase::Row& row ) throw( DirectoryData::Exception );
	};

	class DirectoryData_Export IncorporationMap : public std::map<Incorporation::Key, Incorporation>
	{
		public:
			static IncorporationMap fromResult( const RfcDal::DalDatabase::Result& result ) throw( DirectoryData::Exception );
	};
}

#endif /* !__DirectoryData_Incorporation_h__ */
