#ifndef __DirectoryData_Mailer_h__
#define __DirectoryData_Mailer_h__

#include <DirectoryData/Exception.h>
#include <DirectoryData/Message.h>

#include <Mail4c/MailerBroker.h>

namespace DirectoryData
{
	class Mailer
	{
		private:
			Mail4c::Mailer* _pmailer;

		public:
			Mailer();

			void initialize( const std::string& strSharedObject, const std::string& strMTA ) throw( DirectoryData::Exception );

			void saveMessage( Message& message ) throw( DirectoryData::Exception );
			void sendMessage( Message& message ) throw( DirectoryData::CompoundException, DirectoryData::Exception );

		private:
			Mail4c::Mailer& mailer() throw( DirectoryData::Exception );
	};
}

#endif /* !__DirectoryData_Mailer_h__ */
