#ifndef __DirectoryData_MerchantType_h__
#define __DirectoryData_MerchantType_h__

#include <DirectoryData/Enumerator.h>
#include <DirectoryData/Exception.h>

#include <librfcdal/DalDatabase.h>

#include <map>

namespace DirectoryData
{
	class DirectoryData_Export MerchantType : public Enumerator
	{
		public:
			MerchantType();
			MerchantType( const MerchantType::Key & key );
			MerchantType( const MerchantType& type );
			virtual ~MerchantType();

			MerchantType& operator=( const MerchantType& type );

			static MerchantType fromRow( const RfcDal::DalDatabase::Row& row ) throw( DirectoryData::Exception );
			static MerchantType create( const MerchantType& type ) throw( DirectoryData::Exception );
			void update() throw( DirectoryData::Exception );
	};

	class DirectoryData_Export MerchantTypeMap : public std::map<MerchantType::Key, MerchantType>
	{
		public:
			static MerchantTypeMap fromResult( const RfcDal::DalDatabase::Result& result ) throw( DirectoryData::Exception );
	};
}

#endif /* !__DirectoryData_MerchantType_h__ */
