#ifndef __DirectoryData_MessageStatus_h__
#define __DirectoryData_MessageStatus_h__

#include <DirectoryData/Enumerator.h>
#include <DirectoryData/Exception.h>

#include <librfcdal/DalDatabase.h>

#include <map>

namespace DirectoryData
{
	class DirectoryData_Export MessageStatus : public Enumerator
	{
		public:
			static Key statusNew;
			static Key statusDraft;
			static Key statusPending;
			static Key statusSent;

		public:
			MessageStatus();
			MessageStatus( const MessageStatus::Key & key );
			MessageStatus( const MessageStatus& type );
			virtual ~MessageStatus();

			MessageStatus& operator=( const MessageStatus& type );

			static MessageStatus fromRow( const RfcDal::DalDatabase::Row& row ) throw( DirectoryData::Exception );
	};

	class DirectoryData_Export MessageStatusMap : public std::map<MessageStatus::Key, MessageStatus>
	{
		public:
			static MessageStatusMap fromResult( const RfcDal::DalDatabase::Result& result ) throw( DirectoryData::Exception );
	};
}

#endif /* !__DirectoryData_MessageStatus_h__ */
