#ifndef __DirectoryData_PitchType_h__
#define __DirectoryData_PitchType_h__

#include <DirectoryData/Enumerator.h>
#include <DirectoryData/Exception.h>

#include <librfcdal/DalDatabase.h>

#include <map>

namespace DirectoryData
{
	class DirectoryData_Export PitchType : public Enumerator
	{
		private:
			std::string _strImage;
			bool _bBookable;

		public:
			PitchType();
			PitchType( const PitchType::Key & key );
			PitchType( const PitchType& type );
			virtual ~PitchType();

			PitchType& operator=( const PitchType& type );
			PitchType& merge( const PitchType& type );

			const std::string& image() const;
			bool bookable() const;

			void setImage( const std::string& strImage );
			void setBookable( bool bBookable );

			static PitchType fromRow( const RfcDal::DalDatabase::Row& row ) throw( DirectoryData::Exception );
			static PitchType create( const PitchType& type ) throw( DirectoryData::Exception );
			void update() throw( DirectoryData::Exception );
	};

	class DirectoryData_Export PitchTypeMap : public std::map<PitchType::Key, PitchType>
	{
		public:
			static PitchTypeMap fromResult( const RfcDal::DalDatabase::Result& result ) throw( DirectoryData::Exception );
	};
}

#endif /* !__DirectoryData_PitchType_h__ */
