#ifndef __DirectoryData_Settings_h__
#define __DirectoryData_Settings_h__

#include <DirectoryData/DirectoryData.h>
#include <DirectoryData/Exception.h>

namespace DirectoryData
{
	class DirectoryData_Export Settings
	{
		private:
			static std::string _strFile;
			static std::string _strMap;
			static std::string _strMailer;
			static std::string _strMTA;

		public:
			static void load( const std::string& strFile ) throw( DirectoryData::Exception );

			static const std::string& map();
			static const std::string& mailer();
			static const std::string& mta();

			static void setMap( const std::string& strMap );
			static void setMailer( const std::string& strMailer );
			static void setMTA( const std::string& strMTA );

			static void save() throw( DirectoryData::Exception );
	};
}

#endif /* !__DirectoryData_Settings_h__ */
